<template>
	<view class="content">
		<view class="one">
			<u-swiper :radius="0" :list="config.file" height="240px" indicator indicatorMode="dot" circular></u-swiper>
		</view>
		<view class="two" v-if="config.notice">
			<up-notice-bar :text="config.notice" duration="3000"></up-notice-bar>
		</view>
		<view class="thr">
			<view class="list" v-for="(item, index) in typeList" :key="index">
				<text class="t-icon" :class="[item.icon]"></text>
				<view class="text">{{item.name}}</view>
			</view>
		</view>
		<view class="four">
			<up-tabs :list="subjectList" keyName="label" @click="toTab"></up-tabs>
		</view>
		<view class="five">
			<up-list @scrolltolower="scrolltolower">
				<up-list-item v-for="(item, index) in list" :key="index">
					{{item.nick_name}}
				</up-list-item>
			</up-list>
		</view>
		<up-overlay :show="show">
			<login @showChange='showChange'></login>
		</up-overlay>
	</view>
</template>

<script setup lang="ts">
	import login from "@/components/login.vue"
	import { inject, computed, ref } from 'vue';
	//该依赖已内置不需要单独安装
	import { onShow, onPullDownRefresh } from "@dcloudio/uni-app";
	// 请求接口
	const $api = inject('$api');
	const $apifile = inject('$apifile');
	// 基本信息
	const typeList = ref([
		{ name: '兴趣', icon: 't-icon-xingqu', type: '0' },
		{ name: '小学', icon: 't-icon-xiaoxue', type: '1' },
		{ name: '中学', icon: 't-icon-zhongxue', type: '2' },
		{ name: '高中', icon: 't-icon-gaozhong', type: '3' },
	]);
	const config = ref({ icon: [], logo: [], file: [] });
	// 列表
	const list = ref([]);
	const total = ref(0);
	const skip = ref(0);
	const limit = ref(5);
	const page = ref(0);
	// 数据是否触底
	const is_bottom = ref(false);
	// 字典表
	const subjectList = ref([]);
	// 遮罩层
	const show = ref(false);
	// user
	const user = computed(() => {
		return uni.getStorageSync('user');
	})
	onShow(async () => {
		await searchConfig();
		await searchOther();
		await clearPage();
		await search();
		if (!user.value) show.value = true
	})
	onPullDownRefresh(async () => {
		await clearPage();
		await search();
		uni.stopPullDownRefresh();
	})
	// config信息
	const searchConfig = async () => {
		config.value = uni.getStorageSync('config');
	};
	// 其他查询信息
	const searchOther = async () => {
		let res;
		// 学科
		res = await $api(`dictData`, 'GET', { code: 'subject', is_use: '0' });
		if (res.errcode === 0) subjectList.value = res.data;
		subjectList.value.unshift({ label: '全部', value: '-1', is_show: true })
	};
	// 查询
	const search = async () => {
		const info : any = {
			skip: skip.value,
			limit: limit.value,
			status: '1',
			is_show: '0'
		}
		const res = await $api('teacher', 'GET', info);
		if (res.errcode === 0) {
			list.value = list.value.concat(res.data)
			total.value = res.total
		} else {
			uni.showToast({
				title: res.errmsg || '',
				icon: 'error',
			});
		}
	};
	// 改变标签
	const toTab = async (data) => {
		console.log(data);
	};
	const showChange = () => {
		show.value = false
	}
	const scrolltolower = () => {
		if (total.value > list.value.length) {
			uni.showLoading({
				title: '加载中',
				mask: true
			})
			page.value = page.value + 1;
			skip.value = page.value * limit.value;
			search();
			uni.hideLoading();
		} else is_bottom.value = true
	};
	// 清空列表
	const clearPage = () => {
		list.value = []
		skip.value = 0
		limit.value = 6
		page.value = 0
	};
</script>
<style lang="scss" scoped>
	.content {
		display: flex;
		flex-direction: column;
		background-color: var(--f1Color);

		.two {
			margin: 2vw 2vw 0 2vw;
			border-radius: 5px;
		}

		.thr {
			display: flex;
			justify-content: space-between;
			align-items: center;
			background-color: var(--mainColor);
			margin: 2vw;
			border-radius: 5px;
			padding: 4vw;

			.list {
				display: flex;
				flex-direction: column;
				align-items: center;

				.text {
					margin: 2vw 0 0 0;
					font-size: var(--font14Size);
				}
			}
		}

		.four {
			margin: 2vw;
			border-radius: 5px;
			background-color: var(--mainColor);
		}

		.five {
			margin: 2vw;
			border-radius: 5px;
			background-color: var(--mainColor);
		}
	}
</style>